// Copyright (C) 2024 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

abstract class AuthenticationProvider {}

mixin SignInProvider on AuthenticationProvider {}

mixin SignUpProvider on AuthenticationProvider {}

class EmailPasswordAuthProvider extends AuthenticationProvider
    with SignInProvider, SignUpProvider {
  EmailPasswordAuthProvider({
    required this.email,
    required this.password,
  });
  final String email;
  final String password;
}

class GoogleSignInAuthProvider extends AuthenticationProvider
    with SignInProvider {
  GoogleSignInAuthProvider({
    required this.idToken,
    required this.accessToken,
  });
  final String idToken;
  final String accessToken;
}
